#include <AppKit/AppKit.h>
#include <AppKit/NSImage.h>
#include <Foundation/Foundation.h>

@interface FooView : NSView
@end
@implementation FooView
- (void) setFlipped:(BOOL)flag
{
  _rFlags.flipped_view = flag;
}

- (BOOL) isFlipped
{
  return _rFlags.flipped_view;
}

- (void) drawRect:(NSRect)aRect
{
  if (_rFlags.flipped_view)
    [[NSColor greenColor] set];
  else
    [[NSColor yellowColor] set];
  NSRectFill(_bounds); 
  [[NSImage imageNamed:@"GNUstep"] compositeToPoint:NSMakePoint(0,0) operation:NSCompositeSourceOver];
  [[NSImage imageNamed:@"page_landscape"] compositeToPoint:NSMakePoint(64,64) operation:NSCompositeSourceOver];
}
@end

@interface Foo : NSObject

@end

@implementation Foo 
- (void) applicationWillFinishLaunching:(id)something
{
  NSWindow *win = [[NSWindow alloc] initWithContentRect:NSMakeRect(0,0,256,256)
			styleMask: NSTitledWindowMask|NSClosableWindowMask
			backing:NSBackingStoreBuffered
			defer:NO];

  FooView *vw;
  vw  = [[FooView alloc] initWithFrame:NSMakeRect(0,0,128, 128)];
  [vw setFlipped:YES];
  [[win contentView] addSubview:vw];

  vw = [[FooView alloc] initWithFrame:NSMakeRect(128,128,128, 128)];
  [vw setFlipped:NO];
  [[win contentView] addSubview:vw];
  
  [win makeKeyAndOrderFront:self];  
}
@end
int main()
{
  [NSAutoreleasePool new];
  [[NSApplication sharedApplication] setDelegate:[Foo new]];
  [NSApp run];
  return 0;
}
